*****************************************************************************
*   Visual FoxPro     			*
*****************************************************************************
*  GdiPlus  GdiPlusDraw,  1.0									*
* :  , -, 							*
*****************************************************************************
* :															*
*   () -     			*
*								    					*
*   () 		-    WinApi 	*
*								  RtlMoveMemory								*
*****************************************************************************
#DEFINE CLSID_BMP			"{557CF400-1A04-11D3-9A73-0000F81EF32E}"
#DEFINE CLSID_JPEG			"{557CF401-1A04-11D3-9A73-0000F81EF32E}"
#DEFINE CLSID_GIF			"{557CF402-1A04-11D3-9A73-0000F81EF32E}"
#DEFINE GUID_Quality		"{1d5be4b5-fa4a-452d-9cdd-5db35105e7eb}"
#DEFINE LPTR				0x0040
#DEFINE CF_BITMAP			2
#DEFINE	PixelFormatGDI		0x00020000	&& Is a GDI-supported format
#DEFINE	PixelFormat24bppRGB	(8 + (24 * 256) + PixelFormatGDI)
#DEFINE SRCCOPY				0x00CC0020 

DEFINE CLASS GdiPlus AS Custom 

	PROTECTED gdiplusToken
	PROTECTED nativeImage
	PROTECTED ErrorCode
	nativeImage = 0
	gdiplusToken = 0
	ErrorCode = 0

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  GdiPlus
*+
	PROTECTED PROCEDURE Init
		LOCAL gdiplusStartupInput, lcToken
*
*     DLL
*
		DECLARE INTEGER GdiplusStartup in GdiPlus.dll Long @, String @, Long @
		DECLARE INTEGER GdiplusShutdown in GdiPlus.dll Long
		DECLARE INTEGER GdipLoadImageFromFile in GdiPlus.dll String, Long @
		DECLARE INTEGER GdipSaveImageToFile in GdiPlus.dll Long, String, String @, String @
		DECLARE INTEGER GdipDisposeImage in GdiPlus.dll Long
		DECLARE INTEGER LocalAlloc in Win32API Long, Long
		DECLARE INTEGER LocalFree in Win32API Long
		DECLARE INTEGER UuidFromString in rpcrt4.dll String, String @
		DECLARE INTEGER GdipGetImageHeight in GdiPlus.dll Long, Long @
		DECLARE INTEGER GdipGetImageWidth in GdiPlus.dll Long, Long @
		DECLARE INTEGER GdipCreateBitmapFromScan0 in GdiPlus.dll INTEGER, Integer, Integer, Long, Long, Long @
		DECLARE INTEGER GdipGetImageGraphicsContext in GdiPlus.dll Long, Long @
		DECLARE INTEGER GetWindowDC IN Win32API Long
		DECLARE INTEGER GdipGetDC IN gdiplus INTEGER, INTEGER @
		DECLARE INTEGER GdipReleaseDC IN gdiplus INTEGER, INTEGER
		DECLARE INTEGER BitBlt IN Win32API Long, Long, Long, Long, Long, Long, Long, Long, Long
		DECLARE INTEGER ReleaseDC IN user32 INTEGER hwindow, INTEGER
		DECLARE INTEGER GdipGetImagePixelFormat in GdiPlus.dll Long, Long @
		DECLARE INTEGER GdipImageRotateFlip in GdiPlus.dll Long, Long
		DECLARE INTEGER GdipSetInterpolationMode in GdiPlus.dll Long, Long
		DECLARE INTEGER GdipDrawImageRectI in GdiPlus.dll INTEGER, Long, Integer, Integer, Integer, Integer
		DECLARE INTEGER GdipCloneBitmapAreaI in GdiPlus.dll Long, Long, Long, Long, INTEGER, Long, Long @
		DECLARE INTEGER GdipCreateHBITMAPFromBitmap in GdiPlus.dll INTEGER, Long @, Long
		DECLARE INTEGER DeleteObject in Win32API Long
		DECLARE INTEGER GdipDeleteGraphics IN gdiplus Long
		DECLARE INTEGER GdipCreateFromHWND IN gdiplus Long, Long @
		DECLARE INTEGER RtlMoveMemory IN WIN32API AS RtlCopyIntegerToString STRING @, INTEGER @, INTEGER  
		DECLARE INTEGER RtlMoveMemory IN WIN32API AS RtlCopySingleToString STRING @, SINGLE @, INTEGER  
		DECLARE INTEGER GdipCreatePen1 IN gdiplus INTEGER, SINGLE, INTEGER, INTEGER @
		DECLARE INTEGER GdipSetPenWidth IN gdiplus Long, Integer
		DECLARE INTEGER GdipSetPenDashStyle IN gdiplus Long, INTEGER
		DECLARE INTEGER GdipSetPenColor IN gdiplus Long, Long
		DECLARE INTEGER GdipDeletePen IN gdiplus INTEGER
		DECLARE INTEGER GdipCreateSolidFill IN gdiplus INTEGER, INTEGER @
		DECLARE INTEGER GdipCreateTexture IN gdiplus Long, Long, Long @
		DECLARE INTEGER GdipDeleteBrush IN gdiplus INTEGER
		DECLARE INTEGER GdipDrawRectangleI IN gdiplus Long, Long, INTEGER, INTEGER, INTEGER, INTEGER
		DECLARE INTEGER GdipFillRectangleI IN gdiplus Long, Long, Integer, Integer, Integer, Integer
		DECLARE INTEGER GdipFillEllipseI IN gdiplus Long, Long, Long, Long, Long, Long
		DECLARE INTEGER GdipDrawLineI IN gdiplus Long, Long, INTEGER, INTEGER, INTEGER, INTEGER
		DECLARE INTEGER GdipDrawEllipseI IN gdiplus Long, Long, INTEGER, INTEGER, INTEGER, INTEGER
		DECLARE INTEGER GdipDrawPieI IN gdiplus Long, Long, Long, Long, Long, Long, Single, Single
		DECLARE INTEGER GdipFillPieI IN gdiplus Long, Long, Long, Long, Long, Long, Single, Single
		DECLARE INTEGER GdipDrawPolygonI IN gdiplus Long, Long, String @, Integer
		DECLARE INTEGER GdipFillPolygonI IN gdiplus Long, Long, String @ , Integer, Integer
		DECLARE INTEGER GdipCreateFontFamilyFromName IN gdiplus String @, Integer, Long @
		DECLARE INTEGER GdipCreateFont IN gdiplus Long, Single, Integer, Integer, Long @
		DECLARE INTEGER GdipDeleteFont IN gdiplus Long
		DECLARE INTEGER GdipDeleteFontFamily IN gdiplus Long
		DECLARE INTEGER GdipDrawString IN gdiplus Long, String, Integer, Long, String @, Long, Long
*
*  GDI+
*
		gdiplusStartupInput = Chr(1) + Replicate(Chr(0), 15)
		lcToken = 0
		IF GdiplusStartup(@lcToken, @gdiplusStartupInput, 0) != 0
			RETURN .F.
		ENDIF 
		this.gdiplusToken = lcToken
	ENDPROC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  GDI+
*+
	PROTECTED PROCEDURE Destroy
		this.DisposeImage()					&&    
		IF TYPE('DrawObject') = 'O'
			DrawObject = .f.
		ENDIF 	
		GdiplusShutdown(this.gdiplusToken)	&&  GDI+
		CLEAR DLLS "GdiplusStartup", "GdiplusShutdown", "GdipLoadImageFromFile", "GdipSaveImageToFile"
		CLEAR DLLS "GdipDisposeImage", "LocalAlloc", "LocalFree", "UuidFromString"
		CLEAR DLLS "GdipGetImageHeight", "GdipGetImageWidth", "GdipCreateBitmapFromScan0"
		CLEAR DLLS "GdipGetImageGraphicsContext", "GetWindowDC", "GdipGetDC", "GdipReleaseDC"
		CLEAR DLLS "BitBlt", "ReleaseDC", "GdipGetImagePixelFormat", "GdipImageRotateFlip"
		CLEAR DLLS "GdipSetInterpolationMode", "GdipDrawImageRectI", "GdipCloneBitmapAreaI"
		CLEAR DLLS "GdipCreateHBITMAPFromBitmap", "DeleteObject", "GdipCreateFromHWND"
		CLEAR DLLS "GdipDeleteGraphics", "GdipCreateFromHWND", "RtlCopyIntegerToString"
		CLEAR DLLS "RtlCopySingleToString", "GdipCreatePen1", "GdipSetPenWidth", "GdipSetPenDashStyle"
		CLEAR DLLS "GdipSetPenColor", "GdipDeletePen", "GdipCreateSolidFill", "GdipCreateTexture"
		CLEAR DLLS "GdipDeleteBrush", "GdipDrawRectangleI", "GdipFillRectangleI", "GdipFillEllipseI"
		CLEAR DLLS "GdipDrawLineI", "GdipDrawEllipseI", "GdipDrawPieI", "GdipFillPieI"
		CLEAR DLLS "GdipDrawPolygonI", "GdipFillPolygonI", "GdipCreateFontFamilyFromName", "GdipCreateFont"
		CLEAR DLLS "GdipDeleteFont", "GdipDeleteFontFamily", "GdipDrawString"
	ENDPROC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    
*+
	PROTECTED PROCEDURE DisposeImage
		IF this.nativeImage != 0
			GdipDisposeImage(this.nativeImage)
			this.nativeImage = 0
		ENDIF 
	ENDPROC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  Integer  Long
*+
	PROTECTED FUNCTION DWord(tnValue)
		LOCAL lcString
		lcString = SPACE(4)
		= RtlCopyIntegerToString(@lcStrin, @tnValue, 4)
		RETURN lcString
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    Long
*+
	PROTECTED FUNCTION buf2dword (tcBuffer) 
		RETURN ASC(SUBSTR(tcBuffer, 1,1)) + ASC(SUBSTR(tcBuffer, 2,1)) * 256 +; 
			   ASC(SUBSTR(tcBuffer, 3,1)) * 65536 + ASC(SUBSTR(tcBuffer, 4,1)) * 16777216 
	ENDFUNC 
	
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    UID
*+
	PROTECTED FUNCTION StrToGuid(s)
		LOCAL guid
		guid = Space(16)
		s = Chrtran(s, "{}", "")
		UuidFromString(s, @guid)
		RETURN guid
	ENDFUNC
	 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  BitMap  ( )
*+
	FUNCTION CopyFormToImage(toForm)
		LOCAL bmp, hdcw, hdcg, lnTitle, lnBorder, lnWidth, lnHeight, hwnd
		IF VARTYPE(toForm) = 'O'
			hwnd = toForm.hwnd
			lnWidth = toForm.Width
			lnHeight = toForm.Height
			this.DisposeImage()						&&  
			this.ErrorCode = 1						&& ERROR:   BitMap
			bmp = 0
			IF GdipCreateBitmapFromScan0(lnWidth, lnHeight, 0, PixelFormat24bppRGB, 0, @bmp) = 0
				graphics = 0
				IF GdipGetImageGraphicsContext(bmp, @graphics) = 0
					hdcw = GetWindowDC(hwnd)
					lnWTitle = SYSMETRIC(9)				&&    
					lnWBorder = SYSMETRIC(3)			&&    
					hdcg = 0
					IF GdipGetDC(graphics, @hdcg) = 0
		    			= BitBlt(hdcg, -lnWBorder,-lnWTitle-lnWBorder, lnWidth+lnWBorder, lnHeight+lnWTitle+lnWBorder, hdcw, 0,0, SRCCOPY) 
						GdipReleaseDC(graphics, hdcg)
						this.DisposeImage()
	    				this.nativeImage = bmp
    					this.ErrorCode = 0
					ELSE 
						GdipDisposeImage(bmp)
    				ENDIF 
    				GdipDeleteGraphics(graphics)
				ELSE 
					GdipDisposeImage(bmp)
    			ENDIF 
    			ReleaseDC(hwnd, hdcw) 
    		ENDIF
    	ELSE 
    		this.ErrorCode = 2						&& ERROR:   
    	ENDIF 
    	RETURN this.ErrorCode
	ENDFUNC  

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    
*+
	FUNCTION  LoadFromFile(tcFileName)
		LOCAL lnImage
		IF PCOUNT() = 1
			IF VARTYPE(tcFileName) != 'C'		
				this.ErrorCode = 2				&& ERROR:   
			ELSE 
				IF FILE(tcFileName)
					this.DisposeImage()
					lnImage = 0
					IF GdipLoadImageFromFile(STRCONV(tcFileName+Chr(0),5), @lnImage) = 0
						this.nativeImage = lnImage
						this.ErrorCode = 0
					ELSE 
						this.ErrorCode = 3		&& ERROR:   
					ENDIF 
				ELSE 
					this.ErrorCode = 4			&& ERROR:   
				ENDIF 
			ENDIF 
		ELSE 
			this.ErrorCode = 5					&& ERROR:   
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*+
	FUNCTION ImageWidth
		LOCAL lnWidth

		IF this.nativeImage = 0		&&    
			RETURN 0
		ELSE 	
			lnWidth = 0
			GdipGetImageWidth(this.nativeImage, @lnWidth)
			RETURN lnWidth
		ENDIF 
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*+
	FUNCTION ImageHeight
		LOCAL lnHeight

		IF this.nativeImage = 0		&&    
			RETURN 0
		ELSE 	
			lnHeight = 0
			GdipGetImageHeight(this.nativeImage, @lnHeight)
			RETURN lnHeight
		ENDIF 
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   
*+
	FUNCTION ResizeImage(tnWidth, tnHeight, tnMode)
		LOCAL bmp
		IF this.nativeImage = 0
			this.ErrorCode = 6				&& ERROR:   
		ELSE 
			IF this.VerifyResizeImage(@tnWidth, @tnHeight, @tnMode) = 0
				this.ErrorCode = 0
				IF tnWidth > 0 .or. tnHeight > 0
					bmp = this.nativeImage
					IF this.GoResizeImage(@bmp, tnWidth, tnHeight, tnMode) = 0
						this.DisposeImage()
						this.nativeImage = bmp
					ENDIF 
				ENDIF 
			ENDIF 
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     
*+
	PROTECTED FUNCTION VerifyResizeImage
		PARAMETERS tnWidth, tnHeight, tnMode
		IF VARTYPE(tnWidth) != 'N'
			tnWidth = 0
		ELSE 
			tnWidth = INT(ABS(tnWidth))
		ENDIF 
		IF VARTYPE(tnHeight) != 'N'
			tnHeight = 0
		ELSE 
			tnHeight = INT(ABS(tnHeight))
		ENDIF
		IF VARTYPE(tnMode) != 'N'
			tnMode = 0
		ELSE 
			tnMode = INT(ABS(tnMode))
		ENDIF 
		this.ErrorCode = 0
		IF tnMode < 0 .or. tnMode > 7
			this.ErrorCode = 9
		ENDIF 	
		RETURN this.ErrorCode
	ENDFUNC 
		
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    
*----------------------------------------------------------------------------
*   tnMode -     
*----------------------------------------------------------------------------
* InterpolationModeDefault         		0
* InterpolationModeLowQuality      		1
* InterpolationModeHighQuality     		2
* InterpolationModeBilinear 			3
* InterpolationModeBicubic 				4
* InterpolationModeNearestNeighbor 		5
* InterpolationModeHighQualityBilinear 	6
* InterpolationModeHighQualityBicubic	7
*+
	PROTECTED FUNCTION GoResizeImage
		PARAMETERS bmp, tnWidth, tnHeight, tnMode
		LOCAL lnFormat, newbmp, graphics
		IF tnWidth = 0 .and. tnHeight > 0	&&  
			tnWidth = this.ImageWidth()
		ENDIF 	
		IF tnWidth > 0 .and. tnHeight = 0	&&  
			tnHeight = this.ImageHeight()
		ENDIF 	
		lnFormat = 0
		this.ErrorCode = 14			&& ERROR:     
		IF GdipGetImagePixelFormat(bmp, @lnFormat) = 0
			newbmp = 0
			IF GdipCreateBitmapFromScan0(tnWidth, tnHeight, 0, lnFormat, 0, @newbmp) = 0
				graphics = 0
				IF GdipGetImageGraphicsContext(newbmp, @graphics) = 0
					GdipSetInterpolationMode(graphics, 0)
					IF GdipDrawImageRectI(graphics, this.nativeImage, 0, 0, tnWidth, tnHeight) = 0
						bmp = newbmp
						this.ErrorCode = 0
					ENDIF
					GdipDeleteGraphics(graphics)
				ENDIF 
			ENDIF 		
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    ,  90 
*+
	FUNCTION RotateImage(tnRotate)
		LOCAL lnRotate
		IF this.nativeImage = 0
			this.ErrorCode = 6					&& ERROR:   
		ELSE 
			IF VARTYPE(tnRotate) != 'N'
				this.ErrorCode = 2
			ELSE 
				DO CASE 
					CASE tnRotate = 0
						lnRotate = 0
					CASE tnRotate = 90
						lnRotate = 1
					CASE tnRotate = 180
						lnRotate = 2
					CASE tnRotate = 270
						lnRotate = 3
					OTHERWISE 
						this.ErrorCode = 13				&& ERROR:     
						RETURN this.ErrorCode
				ENDCASE 
				IF GdipImageRotateFlip(this.nativeImage, lnRotate) = 0
					this.ErrorCode = 0
				ELSE 
					this.ErrorCode = 15		&& ERROR:    
				ENDIF 
			ENDIF 
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 	

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    
*+
	FUNCTION CropRect(x, y, tnWidth, tnHeight)
		LOCAL bmp
		IF this.VerifyCropRect(@x, @y, @tnWidth, @tnHeight)
			bmp = this.nativeImage
			IF this.GoCropRect(x, y, tnWidth, tnHeight, @bmp) = 0
				this.DisposeImage()
				this.nativeImage = bmp
				this.ErrorCode = 0
			ENDIF 
		ENDIF
		RETURN this.ErrorCode 
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*      
*+
	PROTECTED FUNCTION VerifyCropRect
		PARAMETERS x, y, tnWidth, tnHeight
		IF VARTYPE(x) != 'N' .or. VARTYPE(y) != 'N' .or. VARTYPE(tnWidth) != 'N' .or. VARTYPE(tnHeight) != 'N'
			this.ErrorCode = 2
			RETURN .f.
		ENDIF
		x = ABS(INT(x))
		y = ABS(INT(y))
		tnWidth = ABS(INT(tnWidth))
		tnHeight = ABS(INT(tnHeight))
		lnWidthImg = this.ImageWidth()
		lnHeightImg = this.ImageHeight()
		IF lnWidthImg < (x + tnWidth)		&&    
			this.ErrorCode = 18				&& ERROR:     
			RETURN .f.
		ENDIF 
		IF lnHeightImg < (x + tnHeight)		&&    
			this.ErrorCode = 18				&& ERROR:     
			RETURN .f.
		ENDIF 
*
*        ,   
*   
*
		IF x > 0 .or. y > 0					&&        
			IF tnWidth = 0					&&     
				tnWidth = lnWidthImg - x	&&     
			ENDIF 
			IF tnHeight = 0					&&     
				tnHeight = lnHeightImg - y
			ENDIF 
		ENDIF 
		RETURN .t.
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*      
*+
	PROTECTED FUNCTION GoCropRect
		PARAMETERS lnX, lnY, lnWidth, lnHeight, bmp
		LOCAL lnFormat, NewBitMap
		this.ErrorCode = 20
		lnFormat = 0
		IF GdipGetImagePixelFormat(bmp, @lnFormat) = 0
			NewBitMap = 0
			IF GdipCloneBitmapAreaI(lnX, lnY, lnWidth, lnHeight, lnFormat, bmp, @NewBitMap) = 0
				bmp = NewBitMap
				this.ErrorCode = 0
			ENDIF
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 			

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     
*+
	FUNCTION CopyToClipBoard
		LOCAL lnFormat, NewBitMap, hReturnBmp, hBmp, hndl
		IF this.nativeImage = 0
			this.ErrorCode = 6					&& ERROR:   
		ELSE 
			DECLARE Long OpenClipboard in Win32API Long hWnd
			DECLARE Long CloseClipboard in Win32API
			DECLARE Long EmptyClipboard in Win32API
			DECLARE Long SetClipboardData in Win32API Long uFormat, Long hMem
			DECLARE Long CopyImage In Win32API Long hImage, Long uType, Long cx, Long cy, Long uFlags
			IF GdipCreateHBITMAPFromBitmap(this.nativeImage, @hReturnBmp, 0xFFFFFFFF) = 0 && 
				hBmp = CopyImage(hReturnBmp, 0, 0, 0, 0)
				DeleteObject(hReturnBmp)
				IF OpenClipboard(0) != 0						&&     
					EmptyClipboard()							&&  
					hndl = SetClipboardData(CF_BITMAP, hBmp)	&&    
					CloseClipboard()							&&   
					IF hndl = 0
						this.ErrorCode = 22						&& ERROR:      
					ENDIF 
				ELSE 
					this.ErrorCode = 23							&& ERROR:     
				ENDIF 
				DeleteObject(hBmp)
			ELSE 
				this.ErrorCode = 1								&& ERROR:   HBITMAP
			ENDIF 
			CLEAR DLLS "OpenClipboard", "CloseClipboard", "EmptyClipboard"
			CLEAR DLLS "SetClipboardData", "CopyImage"
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    
*+
	FUNCTION DrawImageToForm(hWnd, x, y, tnWidth, tnHeight)
		LOCAL graphics, lnX, lnY, lnWidth, lnHeight, lnWidthImg, lnHeightImg, lnScaleX, lnScaleY, lnMaxScale
		IF this.nativeImage = 0
			this.ErrorCode = 6				&& ERROR:   
		ELSE 
			IF PCOUNT() = 5
				IF VARTYPE(hWnd) = 'N' .and. VARTYPE(x) = 'N' .and. VARTYPE(y) = 'N' ;
					.and. VARTYPE(tnWidth) = 'N' .and. VARTYPE(tnHeight) = 'N'
					graphics = 0
					IF GdipCreateFromHWND(hWnd, @graphics) = 0	&&  ,   
						lnWidthImg = this.ImageWidth()
						lnHeightImg = this.ImageHeight()
						lnScaleX = lnWidthImg / tnWidth
						lnScaleY = lnHeightImg / tnHeight
						lnMaxScale = MAX(lnScaleX, lnScaleY)	&&    
						IF lnMaxScale < 1			&&      
							lnMaxScale = 1
						ENDIF 
						lnWidth = ROUND(lnWidthImg / lnMaxScale, 0)		&&  
						lnHeight = ROUND(lnHeightImg / lnMaxScale, 0)
						lnX = x + ROUND(0.5 * (tnWidth - lnWidth), 0)	&& 
						lnY = y + ROUND(0.5 * (tnHeight - lnHeight), 0)
						IF GdipDrawImageRectI(graphics, this.nativeImage, lnX, lnY, lnWidth, lnHeight) = 0
							this.ErrorCode = 0
						ELSE
							this.ErrorCode = 21		&& ERROR:      
						ENDIF 
						GdipDeleteGraphics(graphics)
					ELSE 
						this.ErrorCode = 25
					ENDIF 
				ELSE 
					this.ErrorCode = 2
				ENDIF 
			ELSE 
				this.ErrorCode = 5
			ENDIF 
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    
*+
	FUNCTION CopyToFile(tcFileName, tnQuality, tnWidth, tnHeight, tnMode)
		LOCAL lcFileName, lcEncoderClsid, llFormat, lnQuality, lnWidth, lnHeight, lnMode, lnRet, bmp
		IF EMPTY(tcFileName)
			this.ErrorCode = 7
		ELSE 
			lcFileName = tcFileName
			lcEncoderClsid = ''
			llFormat = .f.
			IF this.VerifyFileName(@lcFileName, @lcEncoderClsid, @llFormat)
				IF llFormat				&&     JPEG
					IF EMPTY(tnQuality)
						lnQuality = 0
					ELSE 
						IF VARTYPE(tnQuality) != 'N'
							this.ErrorCode = 8
							RETURN this.ErrorCode
						ENDIF 
						IF tnQuality < 0 .or. tnQuality > 100
							this.ErrorCode = 10
							RETURN this.ErrorCode
						ELSE 
							lnQuality = ROUND(0.9 * tnQuality,0)
						ENDIF 
					ENDIF 
				ENDIF 
				lnWidth = tnWidth
				lnHeight = tnHeight
				lnMode = tnMode
				llResize = .f.
				bmp = this.nativeImage
				lnRet =  this.VerifyResizeImage(@lnWidth, @lnHeight, @lnMode)
				IF lnWidth > 0 .or. lnHeight > 0	&&      
					IF lnRet > 0					&&      
						RETURN this.ErrorCode		&&   
					ENDIF 	
					IF this.GoResizeImage(@bmp, lnWidth, lnHeight, lnMode) = 0
						this.GoToFile(bmp, lcFileName, lnQuality, llFormat, lcEncoderClsid)
						GdipDisposeImage(bmp)
					ELSE 
						RETURN this.ErrorCode
					ENDIF 	
				ELSE 	
					this.GoToFile(this.nativeImage, lcFileName, lnQuality, llFormat, lcEncoderClsid)
				ENDIF 
			ENDIF 
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*      
*+
	FUNCTION CopyRectToFile(tcFileName, x, y, tnWidth, tnHeight)
		LOCAL bmp
		IF EMPTY(tcFileName)
			this.ErrorCode = 7
		ELSE 
			lcFileName = tcFileName
			lcEncoderClsid = ''
			llFormat = .f.
			IF this.VerifyFileName(@lcFileName, @lcEncoderClsid, @llFormat)
				IF this.VerifyCropRect(@x, @y, @tnWidth, @tnHeight)
					IF tnWidth = 0 .or. tnHeight = 0
						this.GoToFile(this.nativeImage, lcFileName, 0, .f., lcEncoderClsid)
					ELSE 
						bmp = this.nativeImage
						IF this.GoCropRect(X, Y, tnWidth, tnHeight, @bmp) = 0
							this.ErrorCode = 0
							this.GoToFile(bmp, lcFileName, 0, .f., lcEncoderClsid)
							GdipDisposeImage(bmp)
						ENDIF 				
					ENDIF 
				ENDIF 
			ENDIF 	
		ENDIF 	
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*        
*+
	PROTECTED FUNCTION VerifyFileName
		PARAMETERS tcFileName, tcEncoderClsid, tlFormat
		LOCAL lcFileName, lnLenFileName, lcExt
	
		IF VARTYPE(tcFileName) != 'C'
			this.ErrorCode = 2						&& ERROR:   
			RETURN .f.
		ENDIF 
		lcFileName = LOWER(ALLTRIM(tcFileName))
		lnLenFileName = LEN(lcFileName)
		DO WHILE lnLenFileName > 0					&&    
			IF SUBSTR(lcFileName, lnLenFileName,1) != '.'
				EXIT 
			ENDIF 
			lnLenFileName = lnLenFileName - 1
			lcFileName = LEFT(lcFileName, lnLenFileName)	
		ENDDO 
		IF lnLenFileName = 0
			this.ErrorCode = 11						&& ERROR:   
			RETURN .f.
		ENDIF 
		lcExt = JUSTEXT(lcFileName)					&&   () 
		IF LEN(lcExt) = 0
			lcExt = 'jpg'							&&    
			lcFileName = lcFileName + '.' + lcExt
		ENDIF 	
		DO CASE 									&&  CLSID 
			CASE lcExt = 'bmp'
				tcEncoderClsid = this.StrToGuid(CLSID_BMP)
				tlFormat = .f.
			CASE lcExt = 'jpg'
				tcEncoderClsid = this.StrToGuid(CLSID_JPEG)
				tlFormat = .t.
			CASE lcExt = 'gif'
				tcEncoderClsid = this.StrToGuid(CLSID_GIF)
				tlFormat = .f.
			OTHERWISE 
				this.ErrorCode = 3					&& ERROR:   
				RETURN .f.
		ENDCASE 
		tcFileName = STRCONV(tcFileName + Chr(0), 5) &&   Unicode
		RETURN .t.
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     
*+
	PROTECTED FUNCTION GoToFile(bmp, tcFileName, tnQuality, tlFormat, tcEncoderClsid)
		LOCAL lcValuePtr, lcEncoderParam
		this.ErrorCode = 0
		IF tlFormat					&& JPEG-    
			lcValuePtr = LocalAlloc(LPTR, 4)
			IF lcValuePtr = 0
				this.ErrorCode = 16	&& ERROR:    
			ELSE 
				= SYS(2600, lcValuePtr, 4, this.DWord(tnQuality))
				lcEncoderParam = this.DWord(1) + this.StrToGuid(GUID_Quality) + this.DWord(1) + this.DWord(4)
				lcEncoderParam = lcEncoderParam + this.DWord(lcValuePtr)
				IF GdipSaveImageToFile(bmp, tcFileName, @tcEncoderClsid, @lcEncoderParam) != 0
					this.ErrorCode = 17	&& ERROR:    
				ENDIF 
				LocalFree(lcValuePtr)
			ENDIF 
		ELSE						&&   
			IF GdipSaveImageToFile(bmp, tcFileName, @tcEncoderClsid, NULL) != 0
				this.ErrorCode = 17	&& ERROR:    
			ENDIF 
		ENDIF 
		RETURN IIF(this.ErrorCode = 0, .t., .f.)
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*+
	FUNCTION CreateCanvas(tnWidth, tnHeight)
		LOCAL bmp, lnWidth, lnHeight
		IF PCOUNT() = 2
			IF VARTYPE(tnWidth) = 'N' .and. VARTYPE(tnHeight) = 'N'
				lnWidth = ABS(INT(tnWidth))
				lnHeight = ABS(INT(tnHeight))
				IF lnWidth > 16 .and. lnHeight > 16
					this.DisposeImage()
					bmp = 0
					IF GdipCreateBitmapFromScan0(tnWidth, tnHeight, 0, PixelFormat24bppRGB, 0, @bmp) = 0
						this.DisposeImage()
						this.nativeImage = bmp
						this.ErrorCode = 0
					ENDIF 
				ELSE 
					this.ErrorCode = 24
				ENDIF 
			ELSE 
				this.ErrorCode = 2
			ENDIF 	
		ELSE 
			this.ErrorCode = 5
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* 
*+
	FUNCTION GetNativeImage
		RETURN this.nativeImage
	ENDIF 	

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   
*+
	FUNCTION GetErrorMessage
		LOCAL lcText
		DO CASE 
			CASE this.ErrorCode = 0
				lcText = '  '
			CASE this.ErrorCode = 1
				lcText = '   '
			CASE this.ErrorCode = 2
				lcText = '  '
			CASE this.ErrorCode = 3
				lcText = '  '
			CASE this.ErrorCode = 4
				lcText = '  '
			CASE this.ErrorCode = 5
				lcText = '  '
			CASE this.ErrorCode = 6
				lcText = '  '
			CASE this.ErrorCode = 7
				lcText = '     '
			CASE this.ErrorCode = 8
				lcText = '      JPEG'
			CASE this.ErrorCode = 9
				lcText = '  '
			CASE this.ErrorCode = 10
				lcText = '      JPEG'
			CASE this.ErrorCode = 11
				lcText = '  '
			CASE this.ErrorCode = 12
				lcText = '     '
			CASE this.ErrorCode = 13
				lcText = '    '
			CASE this.ErrorCode = 14
				lcText = '    '
			CASE this.ErrorCode = 15
				lcText = '   '
			CASE this.ErrorCode = 16
				lcText = '   '
			CASE this.ErrorCode = 17
				lcText = '   '
			CASE this.ErrorCode = 18
				lcText = '    '
			CASE this.ErrorCode = 19
				lcText = '    '
			CASE this.ErrorCode = 20
				lcText = '       '
			CASE this.ErrorCode = 21
				lcText = '     '
			CASE this.ErrorCode = 22
				lcText = '     Windows'
			CASE this.ErrorCode = 23
				lcText = '    '
			CASE this.ErrorCode = 24
				lcText = '  '
			OTHERWISE 
				lcText = '...'
		ENDCASE 
		RETURN LTRIM(STR(this.ErrorCode))+': ' + lcText
	ENDFUNC 

ENDDEFINE 

********************************************************************************
*			***************  GdiPlusDraw ************************         * 
********************************************************************************
DEFINE CLASS GdiPlusDraw AS Custom 

	PROTECTED graphics 
	PROTECTED GdiBrush
	PROTECTED GdiPen
	PROTECTED GdiFont
	PROTECTED ErrorCode
	PROTECTED ImageWidth
	PROTECTED ImageHeight
	graphics = 0
	GdiBrush = 0
	GdiPen = 0
	GdiFont = 0
	ErrorCode = 0
	ImageWidth = 0
	ImageHeight = 0

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* 
*+
	PROTECTED PROCEDURE Init
		LPARAMETERS oGP  			&&    GdiPlus
		LOCAL nativeImage, graphicsobj, lnWidth, lnHeight
	
		IF VARTYPE(oGP) != 'O'
			RETURN .f.
		ENDIF 	
		nativeImage = oGP.GetNativeImage()			&&  
		this.ImageWidth = oGP.ImageWidth()			&&  
		this.ImageHeight = oGP.ImageHeight()		&&  
		graphicsobj = 0
		IF GdipGetImageGraphicsContext(nativeImage, @graphicsobj) = 0
			this.graphics = graphicsobj
		ELSE 
			RETURN .f.
		ENDIF 	
	ENDPROC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* 
*+
	PROTECTED PROCEDURE Destroy
		LOCAL llError
		llError = .f.
		TRY 
			IF 	this.GdiBrush != 0
				this.DeleteBrush()
			ENDIF 	
			IF this.GdiPen != 0
				this.DeletePen()
			ENDIF 	
			IF this.GdiFont != 0
				this.DeleteFont()
			ENDIF 
			GdipDeleteGraphics(this.graphics )
		CATCH 
			llError = .t.
		ENDTRY 
		IF llError
			= MESSAGEBOX(' GdiPlus   ' + CHR(13) + ;
						 ' Destroy  GdiPlusDraw',64,'  GdiPlusDraw',3000)
		ENDIF 
	ENDPROC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  Integer  Long
*+
	PROTECTED FUNCTION DWord(tnValue)
		LOCAL lcString
		lcString = SPACE(4)
		= RtlCopyIntegerToString(@lcString, @tnValue, 4)
		RETURN lcString
	ENDFUNC 		
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  Single  
*+
	PROTECTED FUNCTION SingleToStr(tnSingle)
		LOCAL lcBuff
		lcBuff = SPACE(4)
  		= RtlCopySingleToString(@lcBuff, @tnSingle, 4)  
		RETURN lcBuff
	ENDFUNC  

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    
*+
	PROTECTED FUNCTION GetColor(tnColor, tnAlpha)
		LOCAL blue, green, red
		IF VARTYPE(tnColor) != 'N'
			tnColor = 0					&&   -  
		ELSE 
*
*  GDI+       BGR
*   
*
			blue = BITRSHIFT(BITAND(tnColor, 0x00FF0000), 16)
			green = BITRSHIFT(BITAND(tnColor, 0x0000FF00), 8)
			red = BITAND(tnColor, 0x000000FF)
			tnColor = (blue + BITLSHIFT(green, 8) + BITLSHIFT(red, 16))
		ENDIF 	
		IF VARTYPE(tnAlpha) != 'N'
			tnAlpha = 0xFF				&&   - 
		ELSE 
			IF tnAlpha < 0 .or. tnAlpha > 255
				tnAlpha = 0xFF			&&    Alpha - 
			ELSE 
				tnAlpha = 255 - tnAlpha	&&   : 0 - ; 255 - .
			ENDIF 
		ENDIF 
		RETURN tnColor + BITLSHIFT(tnAlpha, 24)
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    
*+
	PROTECTED FUNCTION VerifyRect
		PARAMETERS x, y, w, h
		IF VARTYPE(x) != 'N'
			x = 0
		ELSE 
			x = ABS(INT(x))
		ENDIF 	
		IF VARTYPE(y) != 'N'
			y = 0
		ELSE 
			y = ABS(INT(y))
		ENDIF 	
		IF VARTYPE(w) != 'N'
			w = 0
		ELSE 
			w = ABS(INT(w))
		ENDIF 	
		IF VARTYPE(h) != 'N'
			h = 0
		ELSE 
			h = ABS(INT(h))
		ENDIF 	
		IF w = 0 .or. h = 0
			RETURN .f.
		ENDIF 	
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*+
	FUNCTION CreateBrush(tnColor, tnAlpha)
		LOCAL GdiBrush
		GdiBrush = 0
		IF GdipCreateSolidFill(this.GetColor(tnColor, tnAlpha), @GdiBrush) = 0
			this.DeleteBrush()					&&    ,   
			this.GdiBrush = GdiBrush
			this.ErrorCode = 0
		ELSE 	
			this.ErrorCode = 3					&& ERROR:   
		ENDIF 	
		RETURN this.ErrorCode
	ENDIF 
	
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   
*+
	FUNCTION CreateTextureBrush(tcFileName)
		LOCAL nativeImg, GdiBrush
		IF VARTYPE(tcFileName) != 'C'
			this.ErrorCode = 1					&& ERROR:   
		ELSE 
			IF FILE(tcFileName)
				nativeImg = 0
				IF GdipLoadImageFromFile(STRCONV(tcFileName + Chr(0), 5), @nativeImg) = 0
					GdiBrush = 0
					IF GdipCreateTexture(nativeImg, 0, @GdiBrush) = 0
						this.DeleteBrush()		&&    ,   
						this.GdiBrush = GdiBrush
						this.ErrorCode = 0		&&  
					ELSE 
						this.ErrorCode = 3		&& ERROR:   
					ENDIF 	
					GdipDisposeImage(nativeImg)
				ELSE 
					this.ErrorCode = 4			&& ERROR:      
				ENDIF 
			ELSE 
				this.ErrorCode = 5				&& ERROR:   
			ENDIF 
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 
	
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*+
	FUNCTION DeleteBrush
		this.ErrorCode = 0
		IF this.GdiBrush != 0					&&    Brush,   
			IF GdipDeleteBrush(this.GdiBrush) = 0
				this.GdiBrush = 0
			ELSE 
				this.ErrorCode = 6				&& ERROR:    
			ENDIF 		
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*+
	FUNCTION CreatePen(tnWidth, tnStyle, tnColor, tnAlpha)
		LOCAL GdiPen
		IF VARTYPE(tnWidth) != 'N'
			tnWidth = 1						&&   -   1 
		ELSE 
			tnWidth = ABS(INT(tnWidth))
		ENDIF 
		IF VARTYPE(tnStyle) != 'N'
			tnStyle = 0						&&   -  
		ELSE 
			tnStyle = ABS(INT(tnStyle))
			IF tnStyle < 0 .or. tnStyle > 4
				tnStyle = 0
			ENDIF 
		ENDIF 			
		GdiPen = 0
		IF GdipCreatePen1(this.GetColor(tnColor, tnAlpha), tnWidth, 0, @GdiPen) = 0
			GdipSetPenDashStyle(GdiPen, tnStyle)
			this.DeletePen()					&&   Pen ,   
			this.GdiPen = GdiPen
			this.ErrorCode = 0				&&  
		ELSE 	
			this.ErrorCode = 3				&& ERROR:   
		ENDIF 	
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    
*+
	FUNCTION SetStylePen(tnStyle)
		IF this.GdiPen = 0
			this.ErrorCode = 7				&& ERROR:   
		ELSE 
			IF VARTYPE(tnStyle) != 'N'
				tnStyle = 0					&&   -  
			ELSE 
				tnStyle = ABS(INT(tnStyle))
				IF tnStyle < 0 .or. tnStyle > 4
					tnStyle = 0
				ENDIF 
			ENDIF 			
			IF GdipSetPenDashStyle(this.GdiPen, tnStyle) = 0
				this.ErrorCode = 0
			ELSE 
				this.ErrorCode = 8			&& ERROR:     
			ENDIF 
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     
*+
	FUNCTION SetWidthPen(tnWidth)
		IF this.GdiPen = 0
			this.ErrorCode = 7				&& ERROR:   
		ELSE 
			IF VARTYPE(tnWidth) != 'N'
				tnWidth = 1					&&   -   1 
			ELSE 
				tnWidth = ABS(INT(tnWidth))
			ENDIF 
			IF GdipSetPenWidth(this.GdiPPen, tnWidth) = 0
				this.ErrorCode = 0
			ELSE 
				this.ErrorCode = 9			&& ERROR:     
			ENDIF 
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     
*+
	FUNCTION SetColorPen(tnColor, tnAlpha)
		IF this.GdiPen = 0
			this.ErrorCode = 7				&& ERROR:   
		ELSE 
			IF GdipSetPenColor(this.GdiPen, this.GetColor(tnColor, tnAlpha)) = 0
				this.ErrorCode = 0
			ELSE 
				this.ErrorCode = 10			&& ERROR:     
			ENDIF 
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*+
	FUNCTION DeletePen
		this.ErrorCode = 0
		IF this.GdiPen != 0					&&    Pen,   
			IF GdipDeletePen(this.GdiPen) = 0
				this.GdiPen = 0
			ELSE 
				this.ErrorCode = 6			&& ERROR:    
			ENDIF 
		ENDIF 
		RETURN this.ErrorCode			
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   ( ) 
*+
	FUNCTION BackGround(tValue)
		LOCAL lValueType, lnColor
		lValueType = VARTYPE(tValue)
		IF lValueType = 'C'
			IF this.CreateTextureBrush(tValue) > 0
				RETURN this.ErrorCode
			ENDIF 	
		ELSE 
			IF lValueType != 'N'
				lnColor = 0
			ELSE 	
				lnColor = tValue
			ENDIF 
			IF this.CreateBrush(lnColor, 0)	> 0
				RETURN this.ErrorCode
			ENDIF 	
		ENDIF 				
		this.ErrorCode = 11				&& ERROR:  
		IF GdipFillRectangleI(this.graphics, this.gdibrush, 0, 0, this.ImageWidth, this.ImageHeight) = 0
			this.ErrorCode = 0
		ENDIF 
		this.DeleteBrush()
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*+
	FUNCTION DrawLine(x1, y1, x2, y2)
		IF this.VerifyRect(@x1, @y1, @x2, @y2)
			IF this.GdiPen = 0
				this.ErrorCode = 7				&& ERROR:   
			ELSE 
				this.ErrorCode = 11				&& ERROR:  
				IF GdipDrawLineI(this.graphics, this.gdiPen, x1, y1, x2, y2) = 0
					this.ErrorCode = 0
				ENDIF 				
			ENDIF 	
		ELSE 
			this.ErrorCode = 2
		ENDIF
		RETURN this.ErrorCode 
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   
*+
	FUNCTION DrawRect(x, y, tnWidth, tnHeight)
		IF this.VerifyRect(@x, @y, @tnWidth, @tnHeight)
			IF this.GdiPen = 0
				this.ErrorCode = 7				&& ERROR:   
			ELSE 
				this.ErrorCode = 11				&& ERROR:  
				IF GdipDrawRectangleI(this.graphics, this.gdiPen, x, y, tnWidth, tnHeight) = 0
					this.ErrorCode = 0
				ENDIF 				
			ENDIF 	
		ELSE 
			this.ErrorCode = 2
		ENDIF
		RETURN this.ErrorCode 
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   
*+
	FUNCTION DrawFillRect(x, y, tnWidth, tnHeight)
		IF this.VerifyRect(@x, @y, @tnWidth, @tnHeight)
			IF this.GdiBrush = 0
				this.ErrorCode = 7				&& ERROR:   
			ELSE 
				this.ErrorCode = 11				&& ERROR:  
				IF GdipFillRectangleI(this.graphics, this.GdiBrush, x, y, tnWidth, tnHeight) = 0
					this.ErrorCode = 0
				ENDIF 				
			ENDIF 	
		ELSE 
			this.ErrorCode = 2
		ENDIF
		RETURN this.ErrorCode 
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   
*+
	FUNCTION DrawEllipse(x, y, tnWidth, tnHeight)
		IF this.VerifyRect(@x, @y, @tnWidth, @tnHeight)
			IF this.GdiPen = 0
				this.ErrorCode = 7				&& ERROR:   
			ELSE 
				this.ErrorCode = 11				&& ERROR:  
				x = INT(x - tnWidth / 2)		&& x  y -  
				y = INT(y - tnHeight / 2)
				IF GdipDrawEllipseI(this.graphics, this.gdiPen, x, y, tnWidth, tnHeight) = 0
					this.ErrorCode = 0
				ENDIF 				
			ENDIF 	
		ELSE 
			this.ErrorCode = 2
		ENDIF
		RETURN this.ErrorCode 
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   
*+
	FUNCTION DrawFillEllipse(x, y, tnWidth, tnHeight)
		IF this.VerifyRect(@x, @y, @tnWidth, @tnHeight)
			IF this.GdiBrush = 0
				this.ErrorCode = 7				&& ERROR:   
			ELSE 
				this.ErrorCode = 11				&& ERROR:  
				x = INT(x - tnWidth / 2)		&& x  y -  
				y = INT(y - tnHeight / 2)
				IF GdipFillEllipseI(this.graphics, this.GdiBrush, x, y, tnWidth, tnHeight) = 0
					this.ErrorCode = 0
				ENDIF 				
			ENDIF 	
		ELSE 
			this.ErrorCode = 2
		ENDIF
		RETURN this.ErrorCode 
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*+
	FUNCTION DrawPie(x, y, tnWidth, tnHeight, tnStart, tnSweep)
		IF this.VerifyRect(@x, @y, @tnWidth, @tnHeight)
			IF VARTYPE(tnStart) = 'N' .or. VARTYPE(tnSweep) = 'N'
				IF this.GdiPen = 0
					this.ErrorCode = 7				&& ERROR:   
				ELSE 
					this.ErrorCode = 11				&& ERROR:  
					x = INT(x - tnWidth / 2)		&& x  y -  
					y = INT(y - tnHeight / 2)
					IF GdipDrawPieI(this.graphics, this.GdiPen, x, y, tnWidth, tnHeight, tnStart, tnSweep) = 0
						this.ErrorCode = 0
					ENDIF 				
				ENDIF 	
			ELSE 
				this.ErrorCode = 1					&& ERROR:   
			ENDIF 
		ELSE 
			this.ErrorCode = 2						&& ERROR:   
		ENDIF
		RETURN this.ErrorCode 
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   
*+
	FUNCTION DrawFillPie(x, y, tnWidth, tnHeight, tnStart, tnSweep)
		IF this.VerifyRect(@x, @y, @tnWidth, @tnHeight)
			IF VARTYPE(tnStart) = 'N' .or. VARTYPE(tnSweep) = 'N'
				IF this.GdiBrush = 0
					this.ErrorCode = 7				&& ERROR:   
				ELSE 
					this.ErrorCode = 11				&& ERROR:  
					x = INT(x - tnWidth / 2)		&& x  y -  
					y = INT(y - tnHeight / 2)
					IF GdipFillPieI(this.graphics, this.GdiBrush, x, y, tnWidth, tnHeight, tnStart, tnSweep) = 0
						this.ErrorCode = 0
					ENDIF 				
				ENDIF 	
			ELSE 
				this.ErrorCode = 1					&& ERROR:   
			ENDIF 
		ELSE 
			this.ErrorCode = 2						&& ERROR:   
		ENDIF
		RETURN this.ErrorCode 
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   
*+
	FUNCTION DrawPolygon
		PARAMETERS taPoint
		IF this.GdiPen = 0
			this.ErrorCode = 7				&& ERROR:   
		ELSE 	
			this.GoPolygon(@taPoint, .f.)
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 	

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   
*+
	FUNCTION DrawFillPolygon
		PARAMETERS taPoint
		IF this.GdiBrush = 0
			this.ErrorCode = 7				&& ERROR:   
		ELSE 	
			this.GoPolygon(@taPoint, .t.)
		ENDIF 	
		RETURN this.ErrorCode
	ENDFUNC 	


*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   
*+
	PROTECTED FUNCTION GoPolygon
		PARAMETERS taPoint, tlFill
		LOCAL i, lnALen, lcDWORD, llError, lnReturn
		llError = .f.
		TRY 
			lnAlen = ALEN(taPoint)
		CATCH
			llError = .t.
		ENDTRY 
		IF llError
			this.errorCode = 12
		ELSE 	
			IF MOD(lnAlen,2) = 0
				lcDWORD = ''
				FOR i = 1 TO lnAlen
					IF VARTYPE(taPoint[i]) != 'N'
						this.ErrorCode = 1
						RETURN this.ErrorCode
					ENDIF
					lcDWORD = lcDWORD + this.DWORD(taPoint[i])
				ENDFOR
				lnAlen = INT(lnAlen/2)
				IF tlFill				&&    
					lnReturn = GdipFillPolygonI(this.graphics, this.GdiBrush, @lcDWORD, lnAlen, 1)
				ELSE 					&&   
					lnReturn = GdipDrawPolygonI(this.graphics, this.GdiPen, @lcDWORD, lnAlen)
				ENDIF 
				IF lnReturn = 0
					this.ErrorCode = 0
				ELSE 
					this.ErrorCode = 11
				ENDIF 	
			ELSE 
				this.ErrorCode = 13
			ENDIF 	
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*+
	FUNCTION CreateFont(tcFontName, tnFontSize, tnFontStyle)
		LOCAL nativeFamily, nativeFont
		IF VARTYPE(tcFontName) != 'C'
			tcFontName = 'Times New Roman'
		ELSE 
			tcFontName = ALLTRIM(tcFontName)
		ENDIF 
		IF VARTYPE(tnFontSize) != 'N'
			tnFontSize = 12
		ELSE 
			tnFontSize = ABS(tnFontSize)
		ENDIF 		
		IF VARTYPE(tnFontStyle) != 'N'
			tnFontStyle = 0
		ELSE 
			IF tnFontStyle < 0 .or. tnFontStyle > 4
				tnFontStyle = 0
			ENDIF 
		ENDIF 			
		nativeFamily = 0
		this.ErrorCode = 14						&& ERROR:    
		IF GdipCreateFontFamilyFromName(STRCONV(tcFontName+Chr(0),5), 0, @nativeFamily) = 0
			nativeFont = 0
			IF GdipCreateFont(nativeFamily, tnFontSize, tnFontStyle, 2, @nativeFont) = 0
				this.DeleteFont()
				this.GdiFont = nativeFont
				this.ErrorCode = 0
			ENDIF 
			GdipDeleteFontFamily(nativeFamily)	
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*+
	FUNCTION DeleteFont
		this.ErrorCode = 0
		IF this.GdiFont != 0
			IF GdipDeleteFont(this.GdiFont) = 0
				this.GdiFont = 0
			ELSE 	
				this.ErrorCode = 6			&& ERROR:    
			ENDIF 
		ENDIF 
		RETURN this.ErrorCode			
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*+
	FUNCTION DrawText(tcText, x, y, tnWidth, tnHeight)
		LOCAL lcRectF
		IF VARTYPE(x) != 'N' .or. VARTYPE(y) != 'N'
			this.ErrorCode = 1
			RETURN this.ErrorCode
		ENDIF 
		IF VARTYPE(tnWidth) != 'N'
			tnWidth = 0.0
		ELSE
			tnWidth = ABS(tnWidth)
		ENDIF 	
		IF VARTYPE(tnHeight) != 'N'
			tnHeight = 0.0
		ELSE
			tnHeight = ABS(tnHeight)
		ENDIF 
		IF VARTYPE(tcText) != 'C'
			thisform.ErrorCode = 1
		ELSE 
			IF LEN(tcText) = 0
				this.ErrorCode = 15
			ELSE 	
				IF this.GdiBrush = 0 .or. this.GdiFont = 0
					this.ErrorCode = 7				&& ERROR:   
				ELSE 
					lcRectF = ''
					lcRectF = lcRectF + this.SingleToStr(x) + this.SingleToStr(y) + ;
							  this.SingleToStr(tnWidth) + this.SingleToStr(tnHeight)
					IF GdipDrawString(this.Graphics, STRCONV(tcText+Chr(0),5), -1, this.GdiFont, ;
									  @lcRectF, 0, this.GdiBrush) = 0
						this.ErrorCode = 0
					ELSE 
						this.ErrorCode = 11		&& ERROR:  
					ENDIF 
				ENDIF 
			ENDIF 			
		ENDIF 
		RETURN this.ErrorCode
	ENDFUNC 

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   
*+
	FUNCTION GetErrorMessage
		LOCAL lcText
		DO CASE 
			CASE this.ErrorCode = 0
				lcText = '  '
			CASE this.ErrorCode = 1
				lcText = '  '
			CASE this.ErrorCode = 2
				lcText = '  '
			CASE this.ErrorCode = 3
				lcText = '  '
			CASE this.ErrorCode = 4
				lcText = '     '
			CASE this.ErrorCode = 5
				lcText = '  '
			CASE this.ErrorCode = 6
				lcText = '   '
			CASE this.ErrorCode = 7
				lcText = '  '
			CASE this.ErrorCode = 8
				lcText = '    '
			CASE this.ErrorCode = 9
				lcText = '    '
			CASE this.ErrorCode = 10
				lcText = '    '
			CASE this.ErrorCode = 11
				lcText = ' '
			CASE this.ErrorCode = 12
				lcText = '    '
			CASE this.ErrorCode = 13
				lcText = '    '
			CASE this.ErrorCode = 14
				lcText = '   '
			CASE this.ErrorCode = 15
				lcText = '    '
			OTHERWISE 
				lcText = '...'
		ENDCASE 
		RETURN LTRIM(STR(this.ErrorCode))+': ' + lcText
	ENDFUNC 

ENDDEFINE